Subject: (IPng 7521) Re: Last Call: IPv6 Jumbograms to Proposed Standa rd

From: Richard Draves <[email-masked]>
Date: Wed, 12 May 1999 21:17:03 -0700

>   We have been thinking a lot about efficiently building 
> headers and I don't
> believe that our technique inherently prevents it. (actually, 
> the way our
> current stuff was architected was designed to help it) One 
> can still precompute
> cached header templates, one for each header. Or you can 
> tweak AH to skip over
> preceding AH headers in the current layer of encapsulation, 
> but that doesn't
> work so well with some fast hash implementations.

Suppose you are building IP-AH-TCP. Will you precompute separate IP, AH, and
TCP header templates and then modify the IP header when you insert AH? It
seems simpler to build a combined IP-AH-TCP template. This reasoning leads
me away from the incremental header insertion implementation model.

>   If you go down this path, it's not clear to me how the AHs 
> will interact.
> Do they always compute with the other AH's ICV fields zeroed? 
> Or do they
> compute with previous ICV fields zeroed and subsequent fields 
> as computed?
> Wouldn't that also imply an implementation's assembly order?

I would compute the AH ICV with previous (outer) AH ICV fields zeroed. I
think it's OK to imply that headers are assembled from inner to outer,
that's logically what happens when an outgoing packet descends the protocol
stack.

Rich
--------------------------------------------------------------------
IETF IPng Working Group Mailing List
IPng Home Page:                      http://playground.sun.com/ipng
FTP archive:                      ftp://playground.sun.com/pub/ipng
Direct all administrative requests to [email-masked]
--------------------------------------------------------------------